//+------------------------------------------------------------------+
//| i4_GoldenLionTrend_v3
//| goldenlion@ukr.net
//| http://GlobeInvestFund.com/
//+------------------------------------------------------------------+
#property copyright "Copyright c 2006,      http://GlobeInvestFund.com/,     goldenlion@ukr.net"
#property link      "http://GlobeInvestFund.com/"


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LightBlue
#property indicator_color2 Pink
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5

//
//
//
//
//

extern int    MyPeriod        = 24;
extern double Dev1            = 1;
extern double Dev2            = 2;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 


//
//
//
//
//

double val1[];
double val2[];
double val3[];
double val4[];
double trend1[];
double trend2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,val1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,val2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,val3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,val4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend1);
   SetIndexBuffer(5,trend2);
return(0);
  }
//+------------------------------------------------------------------+
//| SilverTrend                                                      |
//+------------------------------------------------------------------+
int start()
{   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double bm  = iBands(NULL,0,MyPeriod,0,0,   PRICE_CLOSE,MODE_UPPER,i); 
      double bh1 = iBands(NULL,0,MyPeriod,Dev1,0,PRICE_CLOSE,MODE_UPPER,i);
      double bl1 = iBands(NULL,0,MyPeriod,Dev1,0,PRICE_CLOSE,MODE_LOWER,i);
      double bh2 = iBands(NULL,0,MyPeriod,Dev2,0,PRICE_CLOSE,MODE_UPPER,i);
      double bl2 = iBands(NULL,0,MyPeriod,Dev2,0,PRICE_CLOSE,MODE_LOWER,i);
      
      //
      //
      //
      //
      //
      
      val1[i] = EMPTY_VALUE; 
      val2[i] = EMPTY_VALUE; 
      val3[i] = EMPTY_VALUE; 
      val4[i] = EMPTY_VALUE; 
      trend1[i] = 0;
      trend2[i] = 0;

      if(Low[i]>bh1)  trend1[i] = 1; 
      if(High[i]<bl1) trend1[i] =-1; 
      if(Low[i]>bh2)  trend2[i] = 1;
      if(High[i]<bl2) trend2[i] =-1;
      if (trend1[i] == 1) { val1[i] = High[i]; val2[i] = Low[i];  }
      if (trend1[i] ==-1) { val1[i] = Low[i];  val2[i] = High[i]; } 
      if (trend2[i] == 1) { val3[i] = High[i]; val4[i] = Low[i];  val1[i] = EMPTY_VALUE; val2[i] = EMPTY_VALUE; }
      if (trend2[i] ==-1) { val3[i] = Low[i];  val4[i] = High[i]; val1[i] = EMPTY_VALUE; val2[i] = EMPTY_VALUE; } 
   }
   
   //
   //
   //
   //
   //
   
    if (alertsOn)
     {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
       
        if (trend1[whichBar] == 1) doAlert("changed to up");
        if (trend1[whichBar] ==-1) doAlert("changed to down");  
     }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," GoldenLionTrend ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " GoldenLionTrend  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}